#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 17 "gram.y"
#include <config.h>
#include <includes.h>
#include <radvd.h>
#include <defaults.h>

extern struct Interface *IfaceList;
struct Interface *iface = NULL;
struct AdvPrefix *prefix = NULL;
struct AdvRoute *route = NULL;

extern char *conf_file;
extern int num_lines;
extern char *yytext;
extern int sock;

static void cleanup(void);
static void yyerror(char *msg);

#if 0 /* no longer necessary? */
#ifndef HAVE_IN6_ADDR_S6_ADDR
# ifdef __FreeBSD__
#  define s6_addr32 __u6_addr.__u6_addr32
#  define s6_addr16 __u6_addr.__u6_addr16
# endif
#endif
#endif

#define ABORT	do { cleanup(); YYABORT; } while (0);

#line 103 "gram.y"
typedef union {
	unsigned int		num;
	int			snum;
	double			dec;
	int			bool;
	struct in6_addr		*addr;
	char			*str;
	struct AdvPrefix	*pinfo;
	struct AdvRoute		*rinfo;
} YYSTYPE;
#line 58 "y.tab.c"
#define YYERRCODE 256
#define T_INTERFACE 257
#define T_PREFIX 258
#define T_ROUTE 259
#define STRING 260
#define NUMBER 261
#define SIGNEDNUMBER 262
#define DECIMAL 263
#define SWITCH 264
#define IPV6ADDR 265
#define INFINITY 266
#define T_IgnoreIfMissing 267
#define T_AdvSendAdvert 268
#define T_MaxRtrAdvInterval 269
#define T_MinRtrAdvInterval 270
#define T_MinDelayBetweenRAs 271
#define T_AdvManagedFlag 272
#define T_AdvOtherConfigFlag 273
#define T_AdvLinkMTU 274
#define T_AdvReachableTime 275
#define T_AdvRetransTimer 276
#define T_AdvCurHopLimit 277
#define T_AdvDefaultLifetime 278
#define T_AdvDefaultPreference 279
#define T_AdvSourceLLAddress 280
#define T_AdvOnLink 281
#define T_AdvAutonomous 282
#define T_AdvValidLifetime 283
#define T_AdvPreferredLifetime 284
#define T_AdvRouterAddr 285
#define T_AdvHomeAgentFlag 286
#define T_AdvIntervalOpt 287
#define T_AdvHomeAgentInfo 288
#define T_Base6to4Interface 289
#define T_UnicastOnly 290
#define T_HomeAgentPreference 291
#define T_HomeAgentLifetime 292
#define T_AdvRoutePreference 293
#define T_AdvRouteLifetime 294
#define T_AdvMobRtrSupportFlag 295
#define T_BAD_TOKEN 296
const short yylhs[] = {                                        -1,
    0,    0,    9,   10,    1,   11,   12,   12,    2,    2,
    5,    5,   13,   13,   14,   14,   14,   14,   14,   14,
   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
   14,   14,   14,   14,   14,   14,   14,   14,    4,    4,
    3,   15,   16,   16,   17,   17,   18,   18,   18,   18,
   18,   18,    7,    7,    6,   19,   20,   20,   21,   21,
   22,   22,    8,    8,
};
const short yylen[] = {                                         2,
    2,    1,    5,    2,    1,    3,    0,    1,    0,    1,
    0,    1,    2,    1,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    1,    2,
    5,    4,    0,    1,    2,    1,    3,    3,    3,    3,
    3,    3,    1,    2,    5,    4,    0,    1,    2,    1,
    3,    3,    1,    1,
};
const short yydefred[] = {                                      0,
    0,    0,    2,    0,    5,    4,    1,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   14,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   39,    0,    0,   13,   21,   22,   16,   19,   15,   18,
   17,   20,   23,   24,   25,   26,   27,   30,   28,   29,
   31,   34,   32,   33,   37,   35,   36,   38,    3,    0,
    0,    6,   53,    0,    0,   40,    0,    0,    0,   54,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   46,
   42,    0,    0,    0,    0,    0,   60,    0,    0,   63,
   64,    0,    0,    0,    0,    0,   45,   56,    0,    0,
    0,   59,   47,   48,   50,   51,   49,   52,   41,   61,
   62,   55,
};
const short yydgoto[] = {                                       2,
    6,   60,   61,   62,   92,   93,   94,  122,    3,    4,
   30,   31,   32,   33,   63,  108,  109,  110,   95,  115,
  116,  117,
};
const short yysindex[] = {                                   -256,
 -240, -256,    0, -100,    0,    0,    0, -262, -224, -220,
 -242, -222, -218, -215, -214, -210, -209, -208, -207, -206,
 -216, -205, -204, -203, -202, -201, -197, -196, -198,  -69,
 -200, -262,    0,   -2,    8,    9,   10,   11,   12,   13,
   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31, -174, -167,
    0, -200,  -30,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   47,
 -170,    0,    0, -167,  -27,    0, -247, -164,   51,    0,
 -246, -165, -163, -234, -234, -162, -240,  -25, -247,    0,
    0, -158, -157, -234,  -21, -246,    0,   48,   49,    0,
    0,   50,   52,   53,   54,   55,    0,    0,   56,   57,
   58,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0, -125,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -122, -123,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -19,
    0, -121,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -15,    0,    0,   -7,    0,    0,    0,
   -6,    0,    0,    0,    0,    0,    0,    0,   -5,    0,
    0,    0,    0,    0,    0,  -69,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,
};
const short yygindex[] = {                                      0,
   32,    0,   59,    0,    0,   33,    0,  -83,  120,    0,
    0,    0,    0,   91,    0,    0,    0,   34,    0,    0,
    0,   35,
};
#define YYTABLESIZE 151
const short yytable[] = {                                       7,
    1,    8,    9,   10,    9,   10,   11,   12,   13,   14,
   15,   16,   17,   18,   19,   20,   21,   22,   36,    5,
   37,  123,    8,   23,   24,   25,  120,   26,   27,   28,
  130,  121,   29,  102,  103,  104,  105,  106,   38,   34,
   39,  107,   40,   35,   41,   49,  113,  114,   42,   43,
   44,   45,   46,   47,   48,   58,   65,   59,   50,   51,
   52,   53,   54,   55,   56,   57,   66,   67,   68,   69,
   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
   90,   91,   97,   98,   99,  101,  111,  112,  118,  126,
  119,  124,  128,  131,  129,   11,  133,  134,  135,   12,
  136,  137,  138,  139,  140,  141,  142,   43,   57,   44,
   96,    7,   64,    0,    0,    0,  100,    0,    0,    0,
    0,    0,    7,    7,    8,    8,    9,   10,  125,    0,
    0,    0,  127,    0,    0,    0,    0,    0,    0,    0,
  132,
};
const short yycheck[] = {                                     125,
  257,  125,  125,  125,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  261,  260,
  263,  105,  123,  286,  287,  288,  261,  290,  291,  292,
  114,  266,  295,  281,  282,  283,  284,  285,  261,  264,
  263,  289,  261,  264,  263,  262,  293,  294,  264,  264,
  261,  261,  261,  261,  261,  125,   59,  258,  264,  264,
  264,  264,  264,  261,  261,  264,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
  265,  259,  123,   47,  265,  123,  261,   47,  264,  125,
  264,  264,  261,  125,  262,  125,   59,   59,   59,  125,
   59,   59,   59,   59,   59,   59,   59,  125,  125,  125,
   62,    2,   32,   -1,   -1,   -1,   94,   -1,   -1,   -1,
   -1,   -1,  258,  259,  258,  259,  259,  259,  107,   -1,
   -1,   -1,  109,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  116,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 296
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"'/'",0,0,0,0,0,0,0,0,0,0,0,"';'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"T_INTERFACE",
"T_PREFIX","T_ROUTE","STRING","NUMBER","SIGNEDNUMBER","DECIMAL","SWITCH",
"IPV6ADDR","INFINITY","T_IgnoreIfMissing","T_AdvSendAdvert",
"T_MaxRtrAdvInterval","T_MinRtrAdvInterval","T_MinDelayBetweenRAs",
"T_AdvManagedFlag","T_AdvOtherConfigFlag","T_AdvLinkMTU","T_AdvReachableTime",
"T_AdvRetransTimer","T_AdvCurHopLimit","T_AdvDefaultLifetime",
"T_AdvDefaultPreference","T_AdvSourceLLAddress","T_AdvOnLink","T_AdvAutonomous",
"T_AdvValidLifetime","T_AdvPreferredLifetime","T_AdvRouterAddr",
"T_AdvHomeAgentFlag","T_AdvIntervalOpt","T_AdvHomeAgentInfo",
"T_Base6to4Interface","T_UnicastOnly","T_HomeAgentPreference",
"T_HomeAgentLifetime","T_AdvRoutePreference","T_AdvRouteLifetime",
"T_AdvMobRtrSupportFlag","T_BAD_TOKEN",
};
const char * const yyrule[] = {
"$accept : grammar",
"grammar : grammar ifacedef",
"grammar : ifacedef",
"ifacedef : ifacehead '{' ifaceparams '}' ';'",
"ifacehead : T_INTERFACE name",
"name : STRING",
"ifaceparams : optional_ifacevlist optional_prefixlist optional_routelist",
"optional_ifacevlist :",
"optional_ifacevlist : ifacevlist",
"optional_prefixlist :",
"optional_prefixlist : prefixlist",
"optional_routelist :",
"optional_routelist : routelist",
"ifacevlist : ifacevlist ifaceval",
"ifacevlist : ifaceval",
"ifaceval : T_MinRtrAdvInterval NUMBER ';'",
"ifaceval : T_MaxRtrAdvInterval NUMBER ';'",
"ifaceval : T_MinDelayBetweenRAs NUMBER ';'",
"ifaceval : T_MinRtrAdvInterval DECIMAL ';'",
"ifaceval : T_MaxRtrAdvInterval DECIMAL ';'",
"ifaceval : T_MinDelayBetweenRAs DECIMAL ';'",
"ifaceval : T_IgnoreIfMissing SWITCH ';'",
"ifaceval : T_AdvSendAdvert SWITCH ';'",
"ifaceval : T_AdvManagedFlag SWITCH ';'",
"ifaceval : T_AdvOtherConfigFlag SWITCH ';'",
"ifaceval : T_AdvLinkMTU NUMBER ';'",
"ifaceval : T_AdvReachableTime NUMBER ';'",
"ifaceval : T_AdvRetransTimer NUMBER ';'",
"ifaceval : T_AdvDefaultLifetime NUMBER ';'",
"ifaceval : T_AdvDefaultPreference SIGNEDNUMBER ';'",
"ifaceval : T_AdvCurHopLimit NUMBER ';'",
"ifaceval : T_AdvSourceLLAddress SWITCH ';'",
"ifaceval : T_AdvIntervalOpt SWITCH ';'",
"ifaceval : T_AdvHomeAgentInfo SWITCH ';'",
"ifaceval : T_AdvHomeAgentFlag SWITCH ';'",
"ifaceval : T_HomeAgentPreference NUMBER ';'",
"ifaceval : T_HomeAgentLifetime NUMBER ';'",
"ifaceval : T_UnicastOnly SWITCH ';'",
"ifaceval : T_AdvMobRtrSupportFlag SWITCH ';'",
"prefixlist : prefixdef",
"prefixlist : prefixlist prefixdef",
"prefixdef : prefixhead '{' optional_prefixplist '}' ';'",
"prefixhead : T_PREFIX IPV6ADDR '/' NUMBER",
"optional_prefixplist :",
"optional_prefixplist : prefixplist",
"prefixplist : prefixplist prefixparms",
"prefixplist : prefixparms",
"prefixparms : T_AdvOnLink SWITCH ';'",
"prefixparms : T_AdvAutonomous SWITCH ';'",
"prefixparms : T_AdvRouterAddr SWITCH ';'",
"prefixparms : T_AdvValidLifetime number_or_infinity ';'",
"prefixparms : T_AdvPreferredLifetime number_or_infinity ';'",
"prefixparms : T_Base6to4Interface name ';'",
"routelist : routedef",
"routelist : routelist routedef",
"routedef : routehead '{' optional_routeplist '}' ';'",
"routehead : T_ROUTE IPV6ADDR '/' NUMBER",
"optional_routeplist :",
"optional_routeplist : routeplist",
"routeplist : routeplist routeparms",
"routeplist : routeparms",
"routeparms : T_AdvRoutePreference SIGNEDNUMBER ';'",
"routeparms : T_AdvRouteLifetime number_or_infinity ';'",
"number_or_infinity : NUMBER",
"number_or_infinity : INFINITY",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 488 "gram.y"

static
void cleanup(void)
{
	if (iface)
		free(iface);
	
	if (prefix)
		free(prefix);
}

static void
yyerror(char *msg)
{
	cleanup();
	flog(LOG_ERR, "%s in %s, line %d: %s", msg, conf_file, num_lines, yytext);
}
#line 355 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 3:
#line 121 "gram.y"
{
			struct Interface *iface2;

			iface2 = IfaceList;
			while (iface2)
			{
				if (!strcmp(iface2->Name, iface->Name))
				{
					flog(LOG_ERR, "duplicate interface "
						"definition for %s", iface->Name);
					ABORT;
				}
				iface2 = iface2->next;
			}			

			if (check_device(sock, iface) < 0) {
				if (iface->IgnoreIfMissing) {
					dlog(LOG_DEBUG, 4, "interface %s did not exist, ignoring the interface", iface->Name);
					goto skip_interface;
				}
				else {
					flog(LOG_ERR, "interface %s does not exist", iface->Name);
					ABORT;
				}
			}
			if (setup_deviceinfo(sock, iface) < 0)
				ABORT;
			if (check_iface(iface) < 0)
				ABORT;
			if (setup_linklocal_addr(sock, iface) < 0)
				ABORT;
			if (setup_allrouters_membership(sock, iface) < 0)
				ABORT;

			iface->next = IfaceList;
			IfaceList = iface;

			dlog(LOG_DEBUG, 4, "interface definition for %s is ok", iface->Name);

skip_interface:
			iface = NULL;
		}
break;
case 4:
#line 165 "gram.y"
{
			iface = malloc(sizeof(struct Interface));

			if (iface == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			iface_init_defaults(iface);
			strncpy(iface->Name, yyvsp[0].str, IFNAMSIZ-1);
			iface->Name[IFNAMSIZ-1] = '\0';
		}
break;
case 5:
#line 180 "gram.y"
{
			/* check vality */
			yyval.str = yyvsp[0].str;
		}
break;
case 6:
#line 187 "gram.y"
{
			iface->AdvPrefixList = yyvsp[-1].pinfo;
			iface->AdvRouteList = yyvsp[0].rinfo;
		}
break;
case 9:
#line 198 "gram.y"
{
			yyval.pinfo = NULL;
		}
break;
case 11:
#line 205 "gram.y"
{
			yyval.rinfo = NULL;
		}
break;
case 15:
#line 216 "gram.y"
{
			iface->MinRtrAdvInterval = yyvsp[-1].num;
		}
break;
case 16:
#line 220 "gram.y"
{
			iface->MaxRtrAdvInterval = yyvsp[-1].num;
		}
break;
case 17:
#line 224 "gram.y"
{
			iface->MinDelayBetweenRAs = yyvsp[-1].num;
		}
break;
case 18:
#line 228 "gram.y"
{
			iface->MinRtrAdvInterval = yyvsp[-1].dec;
		}
break;
case 19:
#line 232 "gram.y"
{
			iface->MaxRtrAdvInterval = yyvsp[-1].dec;
		}
break;
case 20:
#line 236 "gram.y"
{
			iface->MinDelayBetweenRAs = yyvsp[-1].dec;
		}
break;
case 21:
#line 240 "gram.y"
{
			iface->IgnoreIfMissing = yyvsp[-1].bool;
		}
break;
case 22:
#line 244 "gram.y"
{
			iface->AdvSendAdvert = yyvsp[-1].bool;
		}
break;
case 23:
#line 248 "gram.y"
{
			iface->AdvManagedFlag = yyvsp[-1].bool;
		}
break;
case 24:
#line 252 "gram.y"
{
			iface->AdvOtherConfigFlag = yyvsp[-1].bool;
		}
break;
case 25:
#line 256 "gram.y"
{
			iface->AdvLinkMTU = yyvsp[-1].num;
		}
break;
case 26:
#line 260 "gram.y"
{
			iface->AdvReachableTime = yyvsp[-1].num;
		}
break;
case 27:
#line 264 "gram.y"
{
			iface->AdvRetransTimer = yyvsp[-1].num;
		}
break;
case 28:
#line 268 "gram.y"
{
			iface->AdvDefaultLifetime = yyvsp[-1].num;
		}
break;
case 29:
#line 272 "gram.y"
{
			iface->AdvDefaultPreference = yyvsp[-1].snum;
		}
break;
case 30:
#line 276 "gram.y"
{
			iface->AdvCurHopLimit = yyvsp[-1].num;
		}
break;
case 31:
#line 280 "gram.y"
{
			iface->AdvSourceLLAddress = yyvsp[-1].bool;
		}
break;
case 32:
#line 284 "gram.y"
{
			iface->AdvIntervalOpt = yyvsp[-1].bool;
		}
break;
case 33:
#line 288 "gram.y"
{
			iface->AdvHomeAgentInfo = yyvsp[-1].bool;
		}
break;
case 34:
#line 292 "gram.y"
{
			iface->AdvHomeAgentFlag = yyvsp[-1].bool;
		}
break;
case 35:
#line 296 "gram.y"
{
			iface->HomeAgentPreference = yyvsp[-1].num;
		}
break;
case 36:
#line 300 "gram.y"
{
			iface->HomeAgentLifetime = yyvsp[-1].num;
		}
break;
case 37:
#line 304 "gram.y"
{
			iface->UnicastOnly = yyvsp[-1].bool;
		}
break;
case 38:
#line 308 "gram.y"
{
			iface->AdvMobRtrSupportFlag = yyvsp[-1].bool;
		}
break;
case 39:
#line 314 "gram.y"
{
			yyval.pinfo = yyvsp[0].pinfo;
		}
break;
case 40:
#line 318 "gram.y"
{
			yyvsp[0].pinfo->next = yyvsp[-1].pinfo;
			yyval.pinfo = yyvsp[0].pinfo;
		}
break;
case 41:
#line 325 "gram.y"
{
			unsigned int dst;

			if (prefix->AdvPreferredLifetime >
			    prefix->AdvValidLifetime)
			{
				flog(LOG_ERR, "AdvValidLifeTime must be "
					"greater than AdvPreferredLifetime in %s, line %d", 
					conf_file, num_lines);
				ABORT;
			}

			if( prefix->if6to4[0] )
			{
				if (get_v4addr(prefix->if6to4, &dst) < 0)
				{
					flog(LOG_ERR, "interface %s has no IPv4 addresses, disabling 6to4 prefix", prefix->if6to4 );
					prefix->enabled = 0;
				} else
				{
					*((uint16_t *)(prefix->Prefix.s6_addr)) = htons(0x2002);
					memcpy( prefix->Prefix.s6_addr + 2, &dst, sizeof( dst ) );
				}
			}

			yyval.pinfo = prefix;
			prefix = NULL;
		}
break;
case 42:
#line 356 "gram.y"
{
			prefix = malloc(sizeof(struct AdvPrefix));
			
			if (prefix == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			prefix_init_defaults(prefix);

			if (yyvsp[0].num > MAX_PrefixLen)
			{
				flog(LOG_ERR, "invalid prefix length in %s, line %d", conf_file, num_lines);
				ABORT;
			}

			prefix->PrefixLen = yyvsp[0].num;

			memcpy(&prefix->Prefix, yyvsp[-2].addr, sizeof(struct in6_addr));
		}
break;
case 47:
#line 387 "gram.y"
{
			prefix->AdvOnLinkFlag = yyvsp[-1].bool;
		}
break;
case 48:
#line 391 "gram.y"
{
			prefix->AdvAutonomousFlag = yyvsp[-1].bool;
		}
break;
case 49:
#line 395 "gram.y"
{
			prefix->AdvRouterAddr = yyvsp[-1].bool;
		}
break;
case 50:
#line 399 "gram.y"
{
			prefix->AdvValidLifetime = yyvsp[-1].num;
		}
break;
case 51:
#line 403 "gram.y"
{
			prefix->AdvPreferredLifetime = yyvsp[-1].num;
		}
break;
case 52:
#line 407 "gram.y"
{
			dlog(LOG_DEBUG, 4, "using interface %s for 6to4", yyvsp[-1].str);
			strncpy(prefix->if6to4, yyvsp[-1].str, IFNAMSIZ-1);
			prefix->if6to4[IFNAMSIZ-1] = '\0';
		}
break;
case 53:
#line 415 "gram.y"
{
			yyval.rinfo = yyvsp[0].rinfo;
		}
break;
case 54:
#line 419 "gram.y"
{
			yyvsp[0].rinfo->next = yyvsp[-1].rinfo;
			yyval.rinfo = yyvsp[0].rinfo;
		}
break;
case 55:
#line 426 "gram.y"
{
			yyval.rinfo = route;
			route = NULL;
		}
break;
case 56:
#line 434 "gram.y"
{
			route = malloc(sizeof(struct AdvRoute));
			
			if (route == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			route_init_defaults(route, iface);

			if (yyvsp[0].num > MAX_PrefixLen)
			{
				flog(LOG_ERR, "invalid route prefix length in %s, line %d", conf_file, num_lines);
				ABORT;
			}

			route->PrefixLen = yyvsp[0].num;

			memcpy(&route->Prefix, yyvsp[-2].addr, sizeof(struct in6_addr));
		}
break;
case 61:
#line 467 "gram.y"
{
			route->AdvRoutePreference = yyvsp[-1].snum;
		}
break;
case 62:
#line 471 "gram.y"
{
			route->AdvRouteLifetime = yyvsp[-1].num;
		}
break;
case 63:
#line 478 "gram.y"
{
                                yyval.num = yyvsp[0].num; 
                        }
break;
case 64:
#line 482 "gram.y"
{
                                yyval.num = (uint32_t)~0;
                        }
break;
#line 952 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
